<?php
/**
 * Wind Energy functions and definitions
 * @package Wind Energy
 */

if ( ! function_exists( 'wind_energy_after_theme_support' ) ) :

	function wind_energy_after_theme_support() {
		
		add_theme_support( 'automatic-feed-links' );

		add_theme_support('woocommerce');
        add_theme_support('wc-product-gallery-zoom');
        add_theme_support('wc-product-gallery-lightbox');
        add_theme_support('wc-product-gallery-slider');
        add_theme_support('woocommerce', array(
            'gallery_thumbnail_image_width' => 300,
        ));


		add_theme_support(
			'custom-background',
			array(
				'default-color' => 'ffffff',
			)
		);

        load_theme_textdomain( 'wind-energy', get_template_directory() . '/languages' );

		$GLOBALS['content_width'] = apply_filters( 'wind_energy_content_width', 1140 );
		
		add_theme_support( 'post-thumbnails' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 270,
				'width'       => 90,
				'flex-height' => true,
				'flex-width'  => true,
			)
		);
		
		add_theme_support( 'title-tag' );

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'script',
				'style',
			)
		);

		add_theme_support( 'post-formats', array(
			'video',
			'audio',
			'gallery',
			'quote',
			'image',
			'link',
			'status',
			'aside',
			'chat',
		) );
		
		add_theme_support( 'align-wide' );
		add_theme_support( 'responsive-embeds' );
		add_theme_support( 'wp-block-styles' );

		add_editor_style('/lib/custom/css/editor-style.css');

		require get_template_directory() . '/inc/metabox.php';
		require get_template_directory() . '/inc/homepage-setup/homepage-setup-settings.php';

		if (! defined( 'WIND_ENERGY_DOCS_PRO' ) ){
		define('WIND_ENERGY_DOCS_PRO',__('https://layout.omegathemes.com/steps/pro-wind-energy/','wind-energy'));
		}
		if (! defined( 'WIND_ENERGY_BUY_NOW' ) ){
		define('WIND_ENERGY_BUY_NOW',__('https://www.omegathemes.com/products/energy-wordpress-theme','wind-energy'));
		}
		if (! defined( 'WIND_ENERGY_SUPPORT_FREE' ) ){
		define('WIND_ENERGY_SUPPORT_FREE',__('https://wordpress.org/support/theme/wind-energy/','wind-energy'));
		}
		if (! defined( 'WIND_ENERGY_REVIEW_FREE' ) ){
		define('WIND_ENERGY_REVIEW_FREE',__('https://wordpress.org/support/theme/wind-energy/reviews/#new-post/','wind-energy'));
		}
		if (! defined( 'WIND_ENERGY_DEMO_PRO' ) ){
		define('WIND_ENERGY_DEMO_PRO',__('https://layout.omegathemes.com/wind-energy/','wind-energy'));
		}
		if (! defined( 'WIND_ENERGY_LITE_DOCS_PRO' ) ){
		define('WIND_ENERGY_LITE_DOCS_PRO',__('https://layout.omegathemes.com/steps/free-wind-energy/','wind-energy'));
		}
		if (! defined( 'WIND_ENERGY_BUNDLE_BUTTON' ) ){
			define('WIND_ENERGY_BUNDLE_BUTTON',__('https://www.omegathemes.com/products/wp-theme-bundle','wind-energy'));
		}

	}

endif;

add_action( 'after_setup_theme', 'wind_energy_after_theme_support' );

/**
 * Register and Enqueue Styles.
 */
function wind_energy_register_styles() {

	wp_enqueue_style( 'dashicons' );

    $wind_energy_theme_version = wp_get_theme()->get( 'Version' );
	$wind_energy_fonts_url = wind_energy_fonts_url();
    if( $wind_energy_fonts_url ){
    	require_once get_theme_file_path( 'lib/custom/css/wptt-webfont-loader.php' );
        wp_enqueue_style(
			'wind-energy-google-fonts',
			wind_energy_wptt_get_webfont_url( $wind_energy_fonts_url ),
			array(),
			$wind_energy_theme_version
		);
    }

    wp_enqueue_style( 'swiper', get_template_directory_uri() . '/lib/swiper/css/swiper-bundle.min.css');
	wp_enqueue_style( 'wind-energy-style', get_stylesheet_uri(), array(), $wind_energy_theme_version );

	wp_enqueue_style( 'wind-energy-style', get_stylesheet_uri() );
	require get_parent_theme_file_path( '/custom_css.php' );
	wp_add_inline_style( 'wind-energy-style',$wind_energy_custom_css );


	$wind_energy_css = '';

	if ( get_header_image() ) :

		$wind_energy_css .=  '
			.header-navbar{
				background-image: url('.esc_url(get_header_image()).');
				-webkit-background-size: cover !important;
				-moz-background-size: cover !important;
				-o-background-size: cover !important;
				background-size: cover !important;
			}';

	endif;

	wp_add_inline_style( 'wind-energy-style', $wind_energy_css );


	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}	

	wp_enqueue_script( 'imagesloaded' );
    wp_enqueue_script( 'masonry' );
	wp_enqueue_script( 'swiper', get_template_directory_uri() . '/lib/swiper/js/swiper-bundle.min.js', array('jquery'), '', 1);
	wp_enqueue_script( 'wind-energy-custom', get_template_directory_uri() . '/lib/custom/js/theme-custom-script.js', array('jquery'), '', 1);

    // Global Query
    if( is_front_page() ){

    	$wind_energy_posts_per_page = absint( get_option('posts_per_page') );
        $wind_energy_c_paged = ( get_query_var( 'page' ) ) ? absint( get_query_var( 'page' ) ) : 1;
        $wind_energy_posts_args = array(
            'posts_per_page'        => $wind_energy_posts_per_page,
            'paged'                 => $wind_energy_c_paged,
        );
        $wind_energy_posts_qry = new WP_Query( $wind_energy_posts_args );
        $max = $wind_energy_posts_qry->max_num_pages;

    }else{
        global $wp_query;
        $max = $wp_query->max_num_pages;
        $wind_energy_c_paged = ( get_query_var( 'paged' ) > 1 ) ? get_query_var( 'paged' ) : 1;
    }

    $wind_energy_default = wind_energy_get_default_theme_options();
    $wind_energy_pagination_layout = get_theme_mod( 'wind_energy_pagination_layout',$wind_energy_default['wind_energy_pagination_layout'] );
}

add_action( 'wp_enqueue_scripts', 'wind_energy_register_styles',200 );

function wind_energy_admin_enqueue_scripts_callback() {
    if ( ! did_action( 'wp_enqueue_media' ) ) {
    wp_enqueue_media();
    }
    wp_enqueue_script('wind-energy-uploaderjs', get_stylesheet_directory_uri() . '/lib/custom/js/uploader.js', array(), "1.0", true);
}
add_action( 'admin_enqueue_scripts', 'wind_energy_admin_enqueue_scripts_callback' );

/**
 * Register navigation menus uses wp_nav_menu in five places.
 */
function wind_energy_menus() {

	$wind_energy_locations = array(
		'wind-energy-primary-menu'  => esc_html__( 'Primary Menu', 'wind-energy' ),
	);

	register_nav_menus( $wind_energy_locations );
}

add_action( 'init', 'wind_energy_menus' );


add_filter('loop_shop_columns', 'wind_energy_loop_columns');
if (!function_exists('wind_energy_loop_columns')) {
	function wind_energy_loop_columns() {
		$wind_energy_columns = get_theme_mod( 'wind_energy_per_columns', 3 );
		return $wind_energy_columns;
	}
}

add_filter( 'loop_shop_per_page', 'wind_energy_per_page', 20 );
function wind_energy_per_page( $wind_energy_cols ) {
  	$wind_energy_cols = get_theme_mod( 'wind_energy_product_per_page', 9 );
	return $wind_energy_cols;
}

add_filter( 'woocommerce_output_related_products_args', 'wind_energy_products_args' );

function wind_energy_products_args( $wind_energy_args ) {

    $wind_energy_args['posts_per_page'] = get_theme_mod( 'wind_energy_custom_related_products_number', 6 );

    $wind_energy_args['columns'] = get_theme_mod( 'wind_energy_custom_related_products_number_per_row', 3 );

    return $wind_energy_args;
}

require get_template_directory() . '/inc/custom-header.php';
require get_template_directory() . '/classes/class-svg-icons.php';
require get_template_directory() . '/classes/class-walker-menu.php';
require get_template_directory() . '/inc/customizer/customizer.php';
require get_template_directory() . '/inc/custom-functions.php';
require get_template_directory() . '/inc/template-tags.php';
require get_template_directory() . '/classes/body-classes.php';
require get_template_directory() . '/inc/widgets/widgets.php';
require get_template_directory() . '/inc/pagination.php';
require get_template_directory() . '/lib/breadcrumbs/breadcrumbs.php';
require get_template_directory() . '/lib/custom/css/dynamic-style.php';


function wind_energy_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'wind_energy_remove_customize_register', 11 );


function wind_energy_radio_sanitize(  $wind_energy_input, $wind_energy_setting  ) {
	$wind_energy_input = sanitize_key( $wind_energy_input );
	$wind_energy_choices = $wind_energy_setting->manager->get_control( $wind_energy_setting->id )->choices;
	return ( array_key_exists( $wind_energy_input, $wind_energy_choices ) ? $wind_energy_input : $wind_energy_setting->default );
}
require get_template_directory() . '/inc/general.php';

function wind_energy_sticky_sidebar_enabled() {
	$wind_energy_sticky_sidebar = get_theme_mod('wind_energy_sticky_sidebar', true);
	if($wind_energy_sticky_sidebar == false) {
		echo '<style>.widget-area-wrapper {position: relative !important;}</style>';
	}
}

add_action('wp_head', 'wind_energy_sticky_sidebar_enabled');


// NOTICE FUNCTION

function wind_energy_admin_notice() { 
    global $pagenow;
    $theme_args = wp_get_theme();
    $meta = get_option( 'wind_energy_admin_notice' );
    $name = $theme_args->get( 'Name' );
    $current_screen = get_current_screen();

    if ( ! $meta ) {
        if ( is_network_admin() ) {
            return;
        }

        if ( ! current_user_can( 'manage_options' ) ) {
            return;
        }

        if ( $current_screen->base != 'appearance_page_windenergy-wizard' ) {
            ?>
            <div class="notice notice-success notice-content">
                <h2><?php esc_html_e('Welcome! Thank you for choosing Wind Energy. Let’s Set Up Your Website!', 'wind-energy') ?> </h2>
                <p><?php esc_html_e('Before you dive into customization, let’s go through a quick setup process to ensure everything runs smoothly. Click below to start setting up your website in minutes!', 'wind-energy') ?> </p>
                <div class="info-link">
                    <a href="<?php echo esc_url( admin_url( 'themes.php?page=windenergy-wizard' ) ); ?>"><?php esc_html_e('Get Started with Wind Energy', 'wind-energy'); ?></a>
					<a target="_blank" href="<?php echo esc_url( WIND_ENERGY_BUNDLE_BUTTON ); ?>" class="notice-bundle"><?php esc_html_e('Get All WP Themes', 'board-games'); ?></a>
                </div>
                <p class="dismiss-link"><strong><a href="?wind_energy_admin_notice=1"><?php esc_html_e( 'Dismiss', 'wind-energy' ); ?></a></strong></p>
            </div>
            <?php
        }
    }
}
add_action( 'admin_notices', 'wind_energy_admin_notice' );

if ( ! function_exists( 'wind_energy_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
 */
function wind_energy_update_admin_notice() {
    if ( isset( $_GET['wind_energy_admin_notice'] ) && $_GET['wind_energy_admin_notice'] == '1' ) {
        update_option( 'wind_energy_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'wind_energy_update_admin_notice' );

// After Switch theme function
add_action( 'after_switch_theme', 'wind_energy_getstart_setup_options' );
function wind_energy_getstart_setup_options() {
    update_option( 'wind_energy_admin_notice', false );
}